Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.fasterxml.jackson.databind.type
Class MapLikeType

    java.lang.Object
      com.fasterxml.jackson.core.type.ResolvedType
          com.fasterxml.jackson.databind.JavaType
              com.fasterxml.jackson.databind.type.TypeBase
                  com.fasterxml.jackson.databind.type.MapLikeType

All Implemented Interfaces:
  JsonSerializable

Direct Known Subclasses:
  MapType

    public class MapLikeType

extends TypeBase

Type that represents Map-like types; things that consist of key/value pairs but that do not necessarily implement `Map`, but that do not have enough introspection functionality to allow for some level of generic handling. This specifically allows framework to check for configuration and annotation settings used for Map types, and pass these to custom handlers that may be more familiar with actual type.

Field Summary
`protected JavaType` | `_keyType` Type of keys of Map.
`protected JavaType` | `_valueType` Type of values of Map.

Fields inherited from class com.fasterxml.jackson.databind.JavaType
`_class, _hashCode, _typeHandler, _valueHandler`

Constructor Summary
`protected` | `MapLikeType(Class<?> mapType, JavaType keyT, JavaType valueT, Object valueHandler, Object typeHandler)`

Method Summary
`protected JavaType` | `_narrow(Class<?> subclass)`
`protected String` | `buildCanonicalName()`
`static MapLikeType` | `construct(Class<?> rawType, JavaType keyT, JavaType valueT)`
`JavaType` | `containedType(int index)`
`int` | `containedTypeCount()`
`String` | `containedTypeName(int index)` Not sure if we should count on this, but type names for core interfaces are "K" and "V" respectively.
`boolean` | `equals(Object o)`
`JavaType` | `getContentType()`
`StringBuilder` | `getErasedSignature(StringBuilder sb)` Method for accessing signature without generic type information, in form compatible with all versions of JVM, and specifically used for type descriptions when generating byte code.
`StringBuilder` | `getGenericSignature(StringBuilder sb)`
`JavaType` | `getKeyType()`
`boolean` | `isContainerType()`
`boolean` | `isMapLikeType()`
`boolean` | `isTrueMapType()` Method that can be used for checking whether this type is a "real" Collection type; meaning whether it represents a parameterized subtype of `Collection` or just something that acts like one.
`JavaType` | `narrowContentsBy(Class<?> contentClass)`
`JavaType` | `narrowKey(Class<?> keySubclass)`
`String` | `toString()`
`JavaType` | `widenContentsBy(Class<?> contentClass)`
`JavaType` | `widenKey(Class<?> keySubclass)`
`MapLikeType` | `withContentTypeHandler(Object h)` "Copy method" that will construct a new instance that is identical to this instance, except that its content type will have specified type handler assigned.
`MapLikeType` | `withContentValueHandler(Object h)` "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.
`MapLikeType` | `withKeyTypeHandler(Object h)`
`MapLikeType` | `withKeyValueHandler(Object h)`
`MapLikeType` | `withTypeHandler(Object h)` "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.
`MapLikeType` | `withValueHandler(Object h)` "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.

Methods inherited from class com.fasterxml.jackson.databind.type.TypeBase
`_classSignature, getTypeHandler, getValueHandler, serialize, serializeWithType, toCanonical`

Methods inherited from class com.fasterxml.jackson.databind.JavaType
`_assertSubclass, _widen, forcedNarrowBy, getErasedSignature, getGenericSignature, getRawClass, hasGenericTypes, hashCode, hasRawClass, isAbstract, isArrayType, isCollectionLikeType, isConcrete, isEnumType, isFinal, isInterface, isPrimitive, isThrowable, narrowBy, widenBy`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### _keyType

    protected final JavaType _keyType

  Type of keys of Map.

### _valueType

    protected final JavaType _valueType

  Type of values of Map.

Constructor Detail

### MapLikeType

    protected MapLikeType(Class<?> mapType,
                          JavaType keyT,
                          JavaType valueT,
                          Object valueHandler,
                          Object typeHandler)

Method Detail

### construct

    public static MapLikeType construct(Class<?> rawType,
                                        JavaType keyT,
                                        JavaType valueT)

### _narrow

    protected JavaType _narrow(Class<?> subclass)

  Specified by:
    `_narrow` in class `JavaType`

### narrowContentsBy

    public JavaType narrowContentsBy(Class<?> contentClass)

  Specified by:
    `narrowContentsBy` in class `JavaType`

### widenContentsBy

    public JavaType widenContentsBy(Class<?> contentClass)

  Specified by:
    `widenContentsBy` in class `JavaType`

### narrowKey

    public JavaType narrowKey(Class<?> keySubclass)

### widenKey

    public JavaType widenKey(Class<?> keySubclass)

### withTypeHandler

    public MapLikeType withTypeHandler(Object h)

  Description copied from class: `JavaType`
  "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.

  Specified by:
    `withTypeHandler` in class `JavaType`
  Returns:
    Newly created type instance

### withContentTypeHandler

    public MapLikeType withContentTypeHandler(Object h)

  Description copied from class: `JavaType`
  "Copy method" that will construct a new instance that is identical to this instance, except that its content type will have specified type handler assigned.

  Specified by:
    `withContentTypeHandler` in class `JavaType`
  Returns:
    Newly created type instance

### withValueHandler

    public MapLikeType withValueHandler(Object h)

  Description copied from class: `JavaType`
  "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.

  Specified by:
    `withValueHandler` in class `JavaType`
  Returns:
    Newly created type instance

### withContentValueHandler

    public MapLikeType withContentValueHandler(Object h)

  Description copied from class: `JavaType`
  "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.

  Specified by:
    `withContentValueHandler` in class `JavaType`
  Returns:
    Newly created type instance

### buildCanonicalName

    protected String buildCanonicalName()

  Specified by:
    `buildCanonicalName` in class `TypeBase`

### isContainerType

    public boolean isContainerType()

  Specified by:
    `isContainerType` in class `JavaType`
  Returns:
    True if type represented is a container type; this includes array, Map and Collection types.

### isMapLikeType

    public boolean isMapLikeType()

  Overrides:
    `isMapLikeType` in class `JavaType`
  Returns:
    True if type is either true `Map` type, or something similar (meaning it has at least two type parameter; first one describing key type, second value type)

### getKeyType

    public JavaType getKeyType()

  Overrides:
    `getKeyType` in class `JavaType`

### getContentType

    public JavaType getContentType()

  Overrides:
    `getContentType` in class `JavaType`

### containedTypeCount

    public int containedTypeCount()

  Overrides:
    `containedTypeCount` in class `JavaType`

### containedType

    public JavaType containedType(int index)

  Overrides:
    `containedType` in class `JavaType`

### containedTypeName

    public String containedTypeName(int index)

  Not sure if we should count on this, but type names for core interfaces are "K" and "V" respectively. For now let's assume this should work.

  Overrides:
    `containedTypeName` in class `JavaType`

### getErasedSignature

    public StringBuilder getErasedSignature(StringBuilder sb)

  Description copied from class: `JavaType`
  Method for accessing signature without generic type information, in form compatible with all versions of JVM, and specifically used for type descriptions when generating byte code.

  Specified by:
    `getErasedSignature` in class `TypeBase`
  Parameters:
    `sb` - StringBuilder to append signature to
  Returns:
    StringBuilder that was passed in; returned to allow call chaining

### getGenericSignature

    public StringBuilder getGenericSignature(StringBuilder sb)

  Specified by:
    `getGenericSignature` in class `TypeBase`
  Parameters:
    `sb` - StringBuilder to append signature to
  Returns:
    StringBuilder that was passed in; returned to allow call chaining

### withKeyTypeHandler

    public MapLikeType withKeyTypeHandler(Object h)

### withKeyValueHandler

    public MapLikeType withKeyValueHandler(Object h)

### isTrueMapType

    public boolean isTrueMapType()

  Method that can be used for checking whether this type is a "real" Collection type; meaning whether it represents a parameterized subtype of `Collection` or just something that acts like one.

### toString

    public String toString()

  Specified by:
    `toString` in class `JavaType`

### equals

    public boolean equals(Object o)

  Specified by:
    `equals` in class `JavaType`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2012 fasterxml.com. All Rights Reserved.